ScheduledExecutorFactoryBean (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.scheduling.concurrent

## Class ScheduledExecutorFactoryBean

- java.lang.Object
- - org.springframework.util.CustomizableThreadCreator
  - - org.springframework.scheduling.concurrent.CustomizableThreadFactory
    - - org.springframework.scheduling.concurrent.ExecutorConfigurationSupport
      - - org.springframework.scheduling.concurrent.ScheduledExecutorFactoryBean

- All Implemented Interfaces:
    Serializable, ThreadFactory, Aware, BeanNameAware, DisposableBean, FactoryBean<ScheduledExecutorService>, InitializingBean

      public class ScheduledExecutorFactoryBean
      extends ExecutorConfigurationSupport
      implements FactoryBean<ScheduledExecutorService>

  `FactoryBean` that sets up a JDK 1.5 `ScheduledExecutorService` (by default: a `ScheduledThreadPoolExecutor`) and exposes it for bean references.

  Allows for registration of `ScheduledExecutorTasks`, automatically starting the `ScheduledExecutorService` on initialization and cancelling it on destruction of the context. In scenarios that just require static registration of tasks at startup, there is no need to access the `ScheduledExecutorService` instance itself in application code.

  Note that `ScheduledExecutorService` uses a `Runnable` instance that is shared between repeated executions, in contrast to Quartz which instantiates a new Job for each execution.

  WARNING: `Runnables` submitted via a native `ScheduledExecutorService` are removed from the execution schedule once they throw an exception. If you would prefer to continue execution after such an exception, switch this FactoryBean's `"continueScheduledExecutionAfterException"` property to "true".

  Since:
    2.0
  Author:
    Juergen Hoeller
  See Also:
    `setPoolSize(int)`, `ExecutorConfigurationSupport.setThreadFactory(java.util.concurrent.ThreadFactory)`, `ScheduledExecutorTask`, `ScheduledExecutorService`, `ScheduledThreadPoolExecutor`, Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.springframework.scheduling.concurrent.ExecutorConfigurationSupport

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ScheduledExecutorFactoryBean()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected ScheduledExecutorService` | `createExecutor(int poolSize, ThreadFactory threadFactory, RejectedExecutionHandler rejectedExecutionHandler)` Create a new `ScheduledExecutorService` instance.
    `ScheduledExecutorService` | `getObject()` Return an instance (possibly shared or independent) of the object managed by this factory.
    `Class<? extends ScheduledExecutorService>` | `getObjectType()` Return the type of object that this FactoryBean creates, or `null` if not known in advance.
    `protected Runnable` | `getRunnableToSchedule(ScheduledExecutorTask task)` Determine the actual Runnable to schedule for the given task.
    `protected ExecutorService` | `initializeExecutor(ThreadFactory threadFactory, RejectedExecutionHandler rejectedExecutionHandler)` Create the target `ExecutorService` instance.
    `boolean` | `isSingleton()` Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?
    `protected void` | `registerTasks(ScheduledExecutorTask[] tasks, ScheduledExecutorService executor)` Register the specified `ScheduledExecutorTasks` on the given `ScheduledExecutorService`.
    `void` | `setContinueScheduledExecutionAfterException(boolean continueScheduledExecutionAfterException)` Specify whether to continue the execution of a scheduled task after it threw an exception.
    `void` | `setExposeUnconfigurableExecutor(boolean exposeUnconfigurableExecutor)` Specify whether this FactoryBean should expose an unconfigurable decorator for the created executor.
    `void` | `setPoolSize(int poolSize)` Set the ScheduledExecutorService's pool size.
    `void` | `setScheduledExecutorTasks(ScheduledExecutorTask[] scheduledExecutorTasks)` Register a list of ScheduledExecutorTask objects with the ScheduledExecutorService that this FactoryBean creates.

    - ### Methods inherited from class org.springframework.scheduling.concurrent.ExecutorConfigurationSupport

      `afterPropertiesSet, destroy, initialize, setAwaitTerminationSeconds, setBeanName, setRejectedExecutionHandler, setThreadFactory, setThreadNamePrefix, setWaitForTasksToCompleteOnShutdown, shutdown`

    - ### Methods inherited from class org.springframework.scheduling.concurrent.CustomizableThreadFactory

      `newThread`

    - ### Methods inherited from class org.springframework.util.CustomizableThreadCreator

      `createThread, getDefaultThreadNamePrefix, getThreadGroup, getThreadNamePrefix, getThreadPriority, isDaemon, nextThreadName, setDaemon, setThreadGroup, setThreadGroupName, setThreadPriority`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ScheduledExecutorFactoryBean

          public ScheduledExecutorFactoryBean()

  - ### Method Detail

    - #### setPoolSize

          public void setPoolSize(int poolSize)

      Set the ScheduledExecutorService's pool size. Default is 1.

    - #### setScheduledExecutorTasks

          public void setScheduledExecutorTasks(ScheduledExecutorTask[] scheduledExecutorTasks)

      Register a list of ScheduledExecutorTask objects with the ScheduledExecutorService that this FactoryBean creates. Depending on each ScheduledExecutorTask's settings, it will be registered via one of ScheduledExecutorService's schedule methods.
      See Also:
        `ScheduledExecutorService.schedule(java.lang.Runnable, long, java.util.concurrent.TimeUnit)`, `ScheduledExecutorService.scheduleWithFixedDelay(java.lang.Runnable, long, long, java.util.concurrent.TimeUnit)`, `ScheduledExecutorService.scheduleAtFixedRate(java.lang.Runnable, long, long, java.util.concurrent.TimeUnit)`

    - #### setContinueScheduledExecutionAfterException

          public void setContinueScheduledExecutionAfterException(boolean continueScheduledExecutionAfterException)

      Specify whether to continue the execution of a scheduled task after it threw an exception.

      Default is "false", matching the native behavior of a `ScheduledExecutorService`. Switch this flag to "true" for exception-proof execution of each task, continuing scheduled execution as in the case of successful execution.

      See Also:
        `ScheduledExecutorService.scheduleAtFixedRate(java.lang.Runnable, long, long, java.util.concurrent.TimeUnit)`

    - #### setExposeUnconfigurableExecutor

          public void setExposeUnconfigurableExecutor(boolean exposeUnconfigurableExecutor)

      Specify whether this FactoryBean should expose an unconfigurable decorator for the created executor.

      Default is "false", exposing the raw executor as bean reference. Switch this flag to "true" to strictly prevent clients from modifying the executor's configuration.

      See Also:
        `Executors.unconfigurableScheduledExecutorService(java.util.concurrent.ScheduledExecutorService)`

    - #### initializeExecutor

          protected ExecutorService initializeExecutor(ThreadFactory threadFactory,
                                           RejectedExecutionHandler rejectedExecutionHandler)

      Description copied from class: `ExecutorConfigurationSupport`
      Create the target `ExecutorService` instance. Called by `afterPropertiesSet`.
      Specified by:
        `initializeExecutor` in class `ExecutorConfigurationSupport`
      Parameters:
        `threadFactory` - the ThreadFactory to use
        `rejectedExecutionHandler` - the RejectedExecutionHandler to use
      Returns:
        a new ExecutorService instance
      See Also:
        `ExecutorConfigurationSupport.afterPropertiesSet()`

    - #### createExecutor

          protected ScheduledExecutorService createExecutor(int poolSize,
                                                ThreadFactory threadFactory,
                                                RejectedExecutionHandler rejectedExecutionHandler)

      Create a new `ScheduledExecutorService` instance.

      The default implementation creates a `ScheduledThreadPoolExecutor`. Can be overridden in subclasses to provide custom `ScheduledExecutorService` instances.

      Parameters:
        `poolSize` - the specified pool size
        `threadFactory` - the ThreadFactory to use
        `rejectedExecutionHandler` - the RejectedExecutionHandler to use
      Returns:
        a new ScheduledExecutorService instance
      See Also:
        `ExecutorConfigurationSupport.afterPropertiesSet()`, `ScheduledThreadPoolExecutor`

    - #### registerTasks

          protected void registerTasks(ScheduledExecutorTask[] tasks,
                           ScheduledExecutorService executor)

      Register the specified `ScheduledExecutorTasks` on the given `ScheduledExecutorService`.
      Parameters:
        `tasks` - the specified ScheduledExecutorTasks (never empty)
        `executor` - the ScheduledExecutorService to register the tasks on.

    - #### getRunnableToSchedule

          protected Runnable getRunnableToSchedule(ScheduledExecutorTask task)

      Determine the actual Runnable to schedule for the given task.

      Wraps the task's Runnable in a `DelegatingErrorHandlingRunnable` that will catch and log the Exception. If necessary, it will suppress the Exception according to the `"continueScheduledExecutionAfterException"` flag.

      Parameters:
        `task` - the ScheduledExecutorTask to schedule
      Returns:
        the actual Runnable to schedule (may be a decorator)

    - #### getObject

          public ScheduledExecutorService getObject()

      Description copied from interface: `FactoryBean`
      Return an instance (possibly shared or independent) of the object managed by this factory.

      As with a `BeanFactory`, this allows support for both the Singleton and Prototype design pattern.

      If this FactoryBean is not fully initialized yet at the time of the call (for example because it is involved in a circular reference), throw a corresponding `FactoryBeanNotInitializedException`.

      As of Spring 2.0, FactoryBeans are allowed to return `null` objects. The factory will consider this as normal value to be used; it will not throw a FactoryBeanNotInitializedException in this case anymore. FactoryBean implementations are encouraged to throw FactoryBeanNotInitializedException themselves now, as appropriate.

      Specified by:
        `getObject` in interface `FactoryBean<ScheduledExecutorService>`
      Returns:
        an instance of the bean (can be `null`)
      See Also:
        `FactoryBeanNotInitializedException`

    - #### getObjectType

          public Class<? extends ScheduledExecutorService> getObjectType()

      Description copied from interface: `FactoryBean`
      Return the type of object that this FactoryBean creates, or `null` if not known in advance.

      This allows one to check for specific types of beans without instantiating objects, for example on autowiring.

      In the case of implementations that are creating a singleton object, this method should try to avoid singleton creation as far as possible; it should rather estimate the type in advance. For prototypes, returning a meaningful type here is advisable too.

      This method can be called before this FactoryBean has been fully initialized. It must not rely on state created during initialization; of course, it can still use such state if available.

      NOTE: Autowiring will simply ignore FactoryBeans that return `null` here. Therefore it is highly recommended to implement this method properly, using the current state of the FactoryBean.

      Specified by:
        `getObjectType` in interface `FactoryBean<ScheduledExecutorService>`
      Returns:
        the type of object that this FactoryBean creates, or `null` if not known at the time of the call
      See Also:
        `ListableBeanFactory.getBeansOfType(java.lang.Class<T>)`

    - #### isSingleton

          public boolean isSingleton()

      Description copied from interface: `FactoryBean`
      Is the object managed by this factory a singleton? That is, will `FactoryBean.getObject()` always return the same object (a reference that can be cached)?

      NOTE: If a FactoryBean indicates to hold a singleton object, the object returned from `getObject()` might get cached by the owning BeanFactory. Hence, do not return `true` unless the FactoryBean always exposes the same reference.

      The singleton status of the FactoryBean itself will generally be provided by the owning BeanFactory; usually, it has to be defined as singleton there.

      NOTE: This method returning `false` does not necessarily indicate that returned objects are independent instances. An implementation of the extended `SmartFactoryBean` interface may explicitly indicate independent instances through its `SmartFactoryBean.isPrototype()` method. Plain `FactoryBean` implementations which do not implement this extended interface are simply assumed to always return independent instances if the `isSingleton()` implementation returns `false`.

      Specified by:
        `isSingleton` in interface `FactoryBean<ScheduledExecutorService>`
      Returns:
        whether the exposed object is a singleton
      See Also:
        `FactoryBean.getObject()`, `SmartFactoryBean.isPrototype()`